'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _levelupDefaults = require('levelup-defaults');

var _levelupDefaults2 = _interopRequireDefault(_levelupDefaults);

var _bytewise = require('bytewise');

var _bytewise2 = _interopRequireDefault(_bytewise);

var _componentType = require('component-type');

var _componentType2 = _interopRequireDefault(_componentType);

var _after = require('after');

var _after2 = _interopRequireDefault(_after);

var _levelDeleteRange = require('level-delete-range');

var _levelDeleteRange2 = _interopRequireDefault(_levelDeleteRange);

var _streamToArray = require('stream-to-array');

var _streamToArray2 = _interopRequireDefault(_streamToArray);

var Pathwise = (function () {
  function Pathwise(db) {
    _classCallCheck(this, Pathwise);

    (0, _assert2['default'])(db, 'db required');
    this._db = (0, _levelupDefaults2['default'])(db, {
      keyEncoding: _bytewise2['default'],
      valueEncoding: 'json'
    });
  }

  _createClass(Pathwise, [{
    key: 'put',
    value: function put(path, obj, opts, fn) {
      if (typeof opts == 'function') {
        ;
        var _ref = [{}, opts];
        opts = _ref[0];
        fn = _ref[1];
      }var batch = opts.batch || this._db.batch();
      this._write(batch, path, obj, fn);
      if (opts.batch) setImmediate(fn);else batch.write(fn);
    }
  }, {
    key: '_write',
    value: function _write(batch, key, obj, fn) {
      var _this = this;

      switch ((0, _componentType2['default'])(obj)) {
        case 'object':
          var keys = Object.keys(obj);
          var next = (0, _after2['default'])(keys.length, fn);
          keys.forEach(function (k) {
            _this._write(batch, key.concat(k), obj[k], next);
          });
          break;
        case 'array':
          this._write(batch, key, arrToObj(obj), fn);
          break;
        default:
          batch.put(key, obj);
          break;
      }
    }
  }, {
    key: 'batch',
    value: function batch(ops, fn) {
      var _this2 = this;

      var batch = this._db.batch();
      var next = (0, _after2['default'])(ops.length, function (err) {
        if (err) return fn(err);
        batch.write(fn);
      });
      ops.forEach(function (op) {
        if (op.type == 'put') _this2.put(op.path, op.data, { batch: batch }, next);else if (op.type == 'del') _this2.del(op.path, { batch: batch }, next);
      });
    }
  }, {
    key: 'get',
    value: function get(path, fn) {
      var ret = {};
      var el = ret;

      (0, _streamToArray2['default'])(this._db.createReadStream({
        start: path,
        end: path.concat(undefined)
      }), function (err, data) {
        if (err) return fn(err);

        data.forEach(function (kv) {
          var segs = kv.key.slice(path.length);
          if (segs.length) {
            segs.forEach(function (seg, idx) {
              if (!el[seg]) {
                if (idx == segs.length - 1) {
                  el[seg] = kv.value;
                } else {
                  el[seg] = {};
                }
              }
              el = el[seg];
            });
            el = ret;
          } else {
            ret = kv.value;
          }
        });
        fn(null, ret);
      });
    }
  }, {
    key: 'del',
    value: function del(path, opts, fn) {
      if (typeof opts == 'function') {
        ;
        var _ref2 = [{}, opts];
        opts = _ref2[0];
        fn = _ref2[1];
      }var batch = opts.batch || this._db.batch();

      (0, _streamToArray2['default'])(this._db.createKeyStream({
        start: path.concat(null),
        end: path.concat(undefined)
      }), function (err, keys) {
        if (err) return fn(err);
        keys.forEach(function (key) {
          return batch.del(key);
        });
        if (opts.batch) fn();else batch.write(fn);
      });
    }
  }, {
    key: 'children',
    value: function children(path, fn) {
      (0, _streamToArray2['default'])(this._db.createReadStream({
        start: path,
        end: path.concat(undefined)
      }), function (err, kv) {
        if (err) return fn(err);
        fn(null, kv.map(function (_kv) {
          return _kv.key[path.length] || _kv.value;
        }));
      });
    }
  }]);

  return Pathwise;
})();

exports['default'] = Pathwise;

function arrToObj(arr) {
  var obj = {};
  arr.forEach(function (el, idx) {
    obj[idx] = el;
  });
  return obj;
}
module.exports = exports['default'];

